package com.filenet.wcm.toolkit.server.operations.contentmanager;

import com.filenet.wcm.api.*;
import com.filenet.wcm.toolkit.server.operations.util.CIConfigProperties;

import filenet.vw.api.*;
import java.io.*;
import java.util.Date;

public class AssignFolder
{
	private static CIConfigProperties conf = null;
    	private static String userId   = "Administrator";
    	private static String password = "password";
    	private static String appId    = "AssignFolder";

    	private static ObjectStore docObjectStore = null;
    	private static Folder docFolder = null;
    	private static Session sess = null;
    	private static boolean error = false;
    	private static VWAttachment vwa = null;
    	private static String guid;

	private static void log(String message)
	{
		String logfilename = "C:\\Integrator.log";
		
		try {
			if (conf==null)	conf = new CIConfigProperties();
			logfilename = conf.getValue("logfilename",logfilename);
			FileWriter file = new FileWriter(logfilename, true);
			BufferedWriter w = new BufferedWriter(file);
			w.write(new Date() + ": ");
			w.write(message);
			w.newLine();
			w.close();
		} catch (Exception e) {}
	}
	
	public static VWAttachment insertFolder(VWAttachment attachment, String objStore, String folderName)
    	{
		log ("insertFolder");
	  	guid = getFolderGUID(objStore, folderName);
	  	if (error)
	  		return attachment;
	  	try
	  	{
	  		vwa = attachment;
	  		vwa.setLibraryName(objStore);
	  		vwa.setLibraryType(VWLibraryType.LIBRARY_TYPE_CONTENT_ENGINE);
	  		vwa.setType(VWAttachmentType.ATTACHMENT_TYPE_FOLDER);
	  		vwa.setId(guid);
	  	}
	  	catch (Exception e)
	  	{
	  		log("Attachment-Error: "+e);
	  	}
	  	return vwa;
    	}

    	private static String getFolderGUID(String objStore, String folderName)
    	{
      		sess = ObjectFactory.getSession(appId, null, userId, password);
	  	if (sess == null)
	  	{
	    		error=true;
	    		log("No session object got!");
	    		return null;
	  	}
	  	log("Session object okay");
	  	if (sess.verify() == null)
	  	{
	    		error=true;
	    		log("No user object got or wrong credentials!");
	    		return null;
	  	}
	  	log("User object okay");
      		docObjectStore = ObjectFactory.getObjectStore(objStore, sess);
	  	if (docObjectStore == null)
	  	{
	    		error=true;
	    		log("No object store object got!");
	    		return null;
	  	}
	  	log("Object store object okay");
	  	docFolder = docObjectStore.getRootFolder();
	  	if (docFolder == null)
	  	{
	    		log("No root folder object got!");
	    		return null;
	  	}
	  	log("Root folder object okay");
      		docFolder = (Folder)docObjectStore.getObject(BaseObject.TYPE_FOLDER, folderName);
	  	if (sess == null)
	  	{
	    		error=true;
	    		log("No folder object got!");
	    		return null;
	  	}
	 	return docFolder.getId();
    	}
}
