package com.filenet.wcm.toolkit.server.operations.contentmanager;

import com.filenet.wcm.api.*;
import com.filenet.wcm.toolkit.server.operations.util.CIConfigProperties;

import filenet.vw.api.*;
import java.io.*;
import java.util.*;

public class CEFolder
{
	private static CIConfigProperties conf = null;
    	private static String userId   = "Administrator";
    	private static String password = "password";
    	private static String appId    = "CEFolder";
	
    	private static ObjectStore objectStore = null;
    	private static Folder rootFolder = null;
    	private static Folder subFolder1 = null;
    	private static Folder subFolder2 = null;
    	private static Session sess = null;

	private static void log(String message)
	{
		String logfilename = "C:\\Integrator.log";
		
		try {
			if (conf==null)	conf = new CIConfigProperties();
			logfilename = conf.getValue("logfilename",logfilename);
			FileWriter file = new FileWriter(logfilename, true);
			BufferedWriter w = new BufferedWriter(file);
			w.write(new Date() + ": ");
			w.write(message);
			w.newLine();
			w.close();
		} catch (Exception e) {}
	}
	
    	public static String newFolder(String objStore, String existingFolderPath, String newFolderPath)
    	{
		String guid = "";
	  	log("CEFolder_newFolder");
      		userId = conf.getValue("ce_user", userId);
      		password = conf.getValue("ce_password", password);	  
	  	sess = ObjectFactory.getSession(appId, null, userId, password);
	  	if (sess == null)
	  	{
	    		log("No session object got!");
	    		return "";
	  	}
	  	log("Session object okay");
	  	if (sess.verify() == null)
	  	{
	    		log("No user object got or wrong credentials!");
	    		return "";
	  	}
	  	log("User object okay");
	  	objStore = conf.getValue("ce_objStore", objStore);
      		objectStore = ObjectFactory.getObjectStore(objStore, sess);
	  	if (objectStore == null)
	  	{
	    		log("No object store object got!");
			return "";
	  	}
	  	log("Object store object okay");
	  	if (existingFolderPath == null || existingFolderPath.equals("") ||
	      	    existingFolderPath.equals(" ") || existingFolderPath.equals("/"))		// root folder
	  	{
	    		rootFolder = objectStore.getRootFolder();
	    		if (rootFolder == null)
	    		{
	      			log("No root folder object got!");
	      			return "";
	    		}
	    		log("Root folder object okay");
	  	}
	  	else
	  	{
	    		rootFolder = (Folder)objectStore.getObject(BaseObject.TYPE_FOLDER, existingFolderPath);
	    		if (rootFolder == null)
	    		{
	      			log("No existing folder object got!");
	      			return "";
	    		}
	    		log("Existing folder object okay");
	  	}
	  	String subFolderName;
	  	StringTokenizer st = new StringTokenizer(newFolderPath,"/");
        	if (st.hasMoreTokens())
        	{ 
	    		subFolderName = st.nextToken();
          		if (subFolderName.length() == 0 && st.hasMoreTokens())
            		subFolderName = st.nextToken();
	    		subFolder1 = rootFolder.addSubFolder(subFolderName, ObjectFactory.getProperties(), null);
	    		if (subFolder1 == null)
	    		{
	      			log("No sub folder object got!");
	      			return "";
	    		}
	    		log("Sub folder object okay");
	    		guid = subFolder1.getId();
	    		if (guid == null)
	    		{
	      			log("No guid object got!");
	      			return "";
	    		}
	    		log("Guid object okay");
        	}
	  	while (st.hasMoreTokens())
	  	{
	     		subFolderName = st.nextToken();
	     		subFolder2 = subFolder1.addSubFolder(subFolderName, ObjectFactory.getProperties(), null);
	      		if (subFolder2 == null)
	      		{
	        		log("No sub folder object got!");
	        		return "";
	      		}
	      		log("Sub folder object okay");
	      		guid = subFolder2.getId();
	      		if (guid == null)
	      		{
	        		log("No guid object got!");
	        		return "";
	      		}
	      		log("Guid object okay");
           		if (st.hasMoreTokens())
	     		{
	       			subFolderName = st.nextToken();
	       			subFolder1 = subFolder2.addSubFolder(subFolderName, ObjectFactory.getProperties(), null);
	    	 		if (subFolder1 == null)
	    	 		{
	         			log("No sub folder object got!");
	         			return "";
	    	 		}
	    	 		log("Sub folder object okay");
	    	 		guid = subFolder1.getId();
	    	 		if (guid == null)
	    	 		{
	         			log("No guid object got!");
	         			return "";
	    	 		}
	    	 		log("Guid object okay");
	     		}
	  	}
		log("Ecerything okay");
		return guid;
    	}

	public static String newSubFolderOfFolder(VWAttachment folder, String folderName)
    	{
		String guid = "";

	  	if (folder.getType() != VWAttachmentType.ATTACHMENT_TYPE_FOLDER)
	  	{
	    		log("Attachment not of type folder!");
	    		return "";
	  	}
  		userId = conf.getValue("ce_user", userId);
  		password = conf.getValue("ce_password", password);	  	
	  	sess = ObjectFactory.getSession(appId, null, userId, password);
	  	if (sess == null)
	  	{
	    		log("No session object got!");
	    		return "";
	  	}
	  	log("Session object okay");
	  	if (sess.verify() == null)
	  	{
	    		log("No user object got or wrong credentials!");
	    		return "";
	  	}
	  	log("User object okay");
          	objectStore = ObjectFactory.getObjectStore(folder.getLibraryName(), sess);
	  	if (objectStore == null)
	  	{
	    		log("No object store object got!");
	    		return "";
	  	}
	  	log("Object store object okay");
          	rootFolder = (Folder)objectStore.getObject(BaseObject.TYPE_FOLDER,folder.getId());
	  	if (rootFolder == null)
	  	{
	    		log("No root folder object got!");
	    		return "";
	  	}
	  	log("Object store object okay");
	  	String subFolderName;
	  	StringTokenizer st = new StringTokenizer(folderName,"/");
          	if (st.hasMoreTokens())
          	{ 
	    		subFolderName = st.nextToken();
            		if (subFolderName.length() == 0 && st.hasMoreTokens())
              			subFolderName = st.nextToken();
	    		subFolder1 = rootFolder.addSubFolder(subFolderName, ObjectFactory.getProperties(), null);
	    		if (subFolder1 == null)
	    		{
	      			log("No sub folder object got!");
	      			return "";
	    		}
	    		log("Sub folder object okay");
	    		guid = subFolder1.getId();
	    		if (guid == null)
	    		{
	      			log("No guid object got!");
	      			return "";
	    		}
	    		log("Guid object okay");
        	}
		while (st.hasMoreTokens())
		{
	     		subFolderName = st.nextToken();
	     		subFolder2 = subFolder1.addSubFolder(subFolderName, ObjectFactory.getProperties(), null);
	      		if (subFolder2 == null)
	      		{
	        		log("No sub folder object got!");
	        		return "";
	      		}
	      		log("Sub folder object okay");
	      		guid = subFolder2.getId();
	      		if (guid == null)
	      		{
	        		log("No guid object got!");
	        		return "";
	      		}
	      		log("Guid object okay");
           		if (st.hasMoreTokens())
	     		{
	       			subFolderName = st.nextToken();
	       			subFolder1 = subFolder2.addSubFolder(subFolderName, ObjectFactory.getProperties(), null);
	    	 		if (subFolder1 == null)
	    	 		{
	         			log("No sub folder object got!");
	         			return "";
	    	 		}
	    	 		log("Sub folder object okay");
	    	 		guid = subFolder1.getId();
	    	 		if (guid == null)
	    	 		{
	         			log("No guid object got!");
	         			return "";
	    	 		}
	    	 		log("Guid object okay");
	     		}
	  	}
	  	log("Everything okay");
	  	return guid;
    	}

    	public static String newSubFolderOfFolderWithClass(VWAttachment folder, String folderName, String folderClass)
    	{
		String guid = "";

	  	if (folder.getType() != VWAttachmentType.ATTACHMENT_TYPE_FOLDER)
	  	{
	    		log("Attachment not of type folder!");
	    		return "";
	  	}
  		userId = conf.getValue("ce_user", userId);
  		password = conf.getValue("ce_password", password);	  	
	  	sess = ObjectFactory.getSession(appId, null, userId, password);
	  	if (sess == null)
	  	{
	    		log("No session object got!");
	    		return "";
	  	}
	  	log("Session object okay");
	  	if (sess.verify() == null)
	  	{
	    		log("No user object got or wrong credentials!");
	    		return "";
	  	}
	  	log("User object okay");
        	objectStore = ObjectFactory.getObjectStore(folder.getLibraryName(), sess);
	  	if (objectStore == null)
	  	{
	    		log("No object store object got!");
	    		return "";
	  	}
	  	log("Object store object okay");
        	rootFolder = (Folder)objectStore.getObject(BaseObject.TYPE_FOLDER,folder.getId());
	  	if (rootFolder == null)
	  	{
	    		log("No root folder object got!");
	    		return "";
	  	}
	  	log("Object store object okay");
	  	String subFolderName;
	  	StringTokenizer st = new StringTokenizer(folderName,"/");
        	if (st.hasMoreTokens())
        	{ 
	    		subFolderName = st.nextToken();
          		if (subFolderName.length() == 0 && st.hasMoreTokens())
            			subFolderName = st.nextToken();
	    		subFolder1 = rootFolder.addSubFolder(subFolderName, folderClass, ObjectFactory.getProperties(), null);
	    		if (subFolder1 == null)
	    		{
	      			log("No sub folder object got!");
	      			return "";
	    		}
	    		log("Sub folder object okay");
	    		guid = subFolder1.getId();
	    		if (guid == null)
	    		{
	      			log("No guid object got!");
	      			return "";
	    		}
	    		log("Guid object okay");
        	}
	  	while (st.hasMoreTokens())
	  	{
	     		subFolderName = st.nextToken();
	     		subFolder2 = subFolder1.addSubFolder(subFolderName, folderClass, ObjectFactory.getProperties(), null);
	      		if (subFolder2 == null)
	      		{
	        		log("No sub folder object got!");
	        		return "";
	      		}
	      		log("Sub folder object okay");
	      		guid = subFolder2.getId();
	      		if (guid == null)
	      		{
	        		log("No guid object got!");
	        		return "";
	      		}
	      		log("Guid object okay");
           		if (st.hasMoreTokens())
	     		{
	       			subFolderName = st.nextToken();
	       			subFolder1 = subFolder2.addSubFolder(subFolderName, folderClass, ObjectFactory.getProperties(), null);
	    	 		if (subFolder1 == null)
	    	 		{
	         			log("No sub folder object got!");
	         			return "";
	    	 		}
	    	 		log("Sub folder object okay");
	    	 		guid = subFolder1.getId();
	    	 		if (guid == null)
	    	 		{
	         			log("No guid object got!");
	         			return "";
	    	 		}
	    	 		log("Guid object okay");
	     		}
	  	}
	  	log("Everything okay");
	  	return guid;
    	}

	/*public static void main(String[] args)
	{
		String guid = newFolder("DMS", "/Kundenakten", "Testfolder");
		System.out.println("fertig, guid = "+guid);
	}*/

}
